/* This linker script generated from xt-genldscripts.tpp for LSP rtos-ramp */
/* Linker Script for default link */
/*  Customer ID=7729; Build=0x71521; Copyright (c) 2005-2018 Tensilica Inc.  */
/*
 *  This is one of four linker scripts generated for general-purpose,
 *  and for use by RTOS in particular.
 *
 *  These scripts have the property that the -Ttext, -Tdata and -Tbss
 *  linker options generally work as expected (unlike the default linker
 *  scripts generated by xt-genldscripts).  That is, these options
 *  move the text, data and/or bss sections in memory as specified.
 *  This approach implies there is NO memory overflow or overlap checking
 *  on the .text, .data and .bss sections because these are directed to
 *  an unrestricted MEMORY region in the linker script (covering 4 GB).
 *
 *  Note:  these linker scripts do not yet have easy support of ROMs
 *	other than the system ROM (eg. of instruction and data ROMs).
 *  Note:  no configuration file *system* info is reflected in these linker
 *	scripts except system ROM, system RAM, and vector locations/sizes.
 *
 *  The four linker scripts emit/pack sections as follows:
 *
 *			<> = vaddr = paddr
 *			{} = vaddr (copied-from-packed or zeroed)
 *			[] = paddr (packed)
 *  rtos-ram LSP:
 *	RAM contents:	<ramvecs>...  <text+rodata><data><bss>
 *	ROM contents:	(none)
 *	---
 *	Linker script for RAM images.
 *	This has no unpack table; the various discontiguous RAM sections
 *	(vectors, etc) are loaded by an external ELF loader.
 *
 *  rtos-ramp LSP:
 *	RAM contents:	{ramvecs}...  <text+rodata+unpack><data>[ramvecs] <bss>
 *	ROM contents:	(none)
 *	---
 *	This script is similar to rtosram.ld, but packs RAM vectors after
 *	the .data section.  The RAM vectors must be unpacked in the image's
 *	initialization code (before any C code).  This arrangement is
 *	necessary when the image gets loaded by anything more complicated
 *	than an assembler loop that immediately jumps to the code, because
 *	otherwise loading the RAM vectors would corrupt operation of
 *	the loading process (eg. VxWorks bootrom has a full kernel
 *	running during boot loading, with TFTP/FTP/RSH/TCP/IP/etc. tasks).
 *	It is also necessary when one needs one contiguous block of bytes,
 *	eg. for compression.
 *
 *  rtos-rom LSP:
 *	RAM contents:	{ramvecs}...  {text+rodata}{data}{bss}
 *	ROM contents:	<romvecs>...  <srom+unpack>[text+rodata][data][ramvecs]
 *	---
 *	Linker script for ROM images, where most sections are copied to RAM
 *	before being executed.  This is a typical scenario when executing
 *	directly from ROM is too slow for normal operation.  The unpacking
 *	code is typically put in the .srom.* sections (or in the reset vector
 *	if it is large enough).
 *
 *  rtos-res LSP:
 *	RAM contents:	{ramvecs}...  {data}{bss}
 *	ROM contents:	<romvecs>...  <srom+text+rodata+unpack>[data][ramvecs]
 *	---
 *	Linker script for ROM images, where code executes directly out of ROM.
 *	Initialized data and RAM vectors need to be copied to RAM, so this
 *	image also needs unpacking code early in initialization.
 *
 *
 *  VxWorks uses these linker scripts as follows:
 *	Image type:	Script			Flags   (lohi = RAM_LOW_ADRS
 *	----------	------			-----        or RAM_HIGH_ADRS)
 *	RAM:		rtosramp.ld	RAM	-Ttext=lohi
 *	ROM-resident:	rtosres.ld	ROM	-Tdata=lohi -Ttext=ROM_TEXT_ADRS
 *	ROM-uncmp:	rtosrom.ld	ROM	-Ttext=lohi
 *	ROM-cmp-inner:	rtosramp.ld	RAM	-Ttext=lohi
 *	ROM-cmp-outer:	rtosrom.ld	ROM	-Ttext=lohi
 *
 */
/*
 *  Virtual memory ranges where sections can be directed
 *  (these are called 'segments' in Xtensa internal documentation).
 *
 *  Entries are of the form:
 *	name (attr) : ORIGIN = e, LENGTH = e
 *	name (attr) : org = e, len = e
 *	name (attr) : o = e, l = e
 *  where attr is a combination of:
 *	R=readonly
 *	W=read/write
 *	X=executable
 *	A=allocated
 *	I=L=initialized
 *	!=invert sense of following attributes
 */
MEMORY
{
  sram0_seg :                         	org = 0xC0000000, len = 0x10000000
  dram0_0_seg :                       	org = 0xE8058000, len = 0x8000
  dram1_0_seg :                       	org = 0xE8060000, len = 0x20000
  iram0_0_seg :                       	org = 0xE8080000, len = 0x400
  iram0_1_seg :                       	org = 0xE8080400, len = 0x180
  iram0_2_seg :                       	org = 0xE8080580, len = 0x40
  iram0_3_seg :                       	org = 0xE80805C0, len = 0x40
  iram0_4_seg :                       	org = 0xE8080600, len = 0x40
  iram0_5_seg :                       	org = 0xE8080640, len = 0x80
  iram0_6_seg :                       	org = 0xE80806C0, len = 0x40
  iram0_7_seg :                       	org = 0xE8080700, len = 0x40
  iram0_8_seg :                       	org = 0xE8080740, len = 0x80
  iram0_9_seg :                       	org = 0xE80807C0, len = 0x7840
  iram1_0_seg :                       	org = 0xE8088000, len = 0x4000
  /*  Entry covering the entire address space, to avoid linker errors
      due to mixing sections that are directed to MEMORY regions and
      others that are not:  */
  ALLMEMORY :				org = 0, len = 0xFFFFFFFF
}

PHDRS
{
/*
 *  ELF linker scripts can contain explicit program headers
 *  (which tell the loader what to load where), eg.:
 *	PHDRS { <entries>... }
 *  where <entries> are of the form:
 *	NAME TYPE [ FILEHDR ] [ PHDRS ] [ AT ( ADDRESS ) ] [ FLAGS ( FLAGS ) ] ;
 */
  packed_phdr PT_LOAD;
  sram0_phdr PT_LOAD;
  iram0_0_phdr PT_LOAD;
}


/*  Default entry point:  */
ENTRY(_start)

/*  Memory boundary addresses:  */
_memmap_mem_sram_start = 0xc0000000;
_memmap_mem_sram_end   = 0xd0000000;
_memmap_mem_dram0_start = 0xe8058000;
_memmap_mem_dram0_end   = 0xe8060000;
_memmap_mem_dram1_start = 0xe8060000;
_memmap_mem_dram1_end   = 0xe8080000;
_memmap_mem_iram0_start = 0xe8080000;
_memmap_mem_iram0_end   = 0xe8088000;
_memmap_mem_iram1_start = 0xe8088000;
_memmap_mem_iram1_end   = 0xe808c000;

/*  Memory segment boundary addresses:  */
_memmap_seg_sram0_start = 0xc0000000;
_memmap_seg_sram0_max   = 0xd0000000;
_memmap_seg_dram0_0_start = 0xe8058000;
_memmap_seg_dram0_0_max   = 0xe8060000;
_memmap_seg_dram1_0_start = 0xe8060000;
_memmap_seg_dram1_0_max   = 0xe8080000;
_memmap_seg_iram0_0_start = 0xe8080000;
_memmap_seg_iram0_0_max   = 0xe8080400;
_memmap_seg_iram0_1_start = 0xe8080400;
_memmap_seg_iram0_1_max   = 0xe8080580;
_memmap_seg_iram0_2_start = 0xe8080580;
_memmap_seg_iram0_2_max   = 0xe80805c0;
_memmap_seg_iram0_3_start = 0xe80805c0;
_memmap_seg_iram0_3_max   = 0xe8080600;
_memmap_seg_iram0_4_start = 0xe8080600;
_memmap_seg_iram0_4_max   = 0xe8080640;
_memmap_seg_iram0_5_start = 0xe8080640;
_memmap_seg_iram0_5_max   = 0xe80806c0;
_memmap_seg_iram0_6_start = 0xe80806c0;
_memmap_seg_iram0_6_max   = 0xe8080700;
_memmap_seg_iram0_7_start = 0xe8080700;
_memmap_seg_iram0_7_max   = 0xe8080740;
_memmap_seg_iram0_8_start = 0xe8080740;
_memmap_seg_iram0_8_max   = 0xe80807c0;
_memmap_seg_iram0_9_start = 0xe80807c0;
_memmap_seg_iram0_9_max   = 0xe8088000;
_memmap_seg_iram1_0_start = 0xe8088000;
_memmap_seg_iram1_0_max   = 0xe808c000;

PROVIDE(_memmap_vecbase_reset = 0xe8080400);
PROVIDE(_memmap_reset_vector = 0xe8080000);
/* Various memory-map dependent cache attribute settings: */
_memmap_cacheattr_wb_base = 0x24024000;
_memmap_cacheattr_wt_base = 0x21021000;
_memmap_cacheattr_bp_base = 0x22022000;
_memmap_cacheattr_unused_mask = 0x00F00FFF;
_memmap_cacheattr_wb_trapnull = 0x2422422F;
_memmap_cacheattr_wba_trapnull = 0x2422422F;
_memmap_cacheattr_wbna_trapnull = 0x2522522F;
_memmap_cacheattr_wt_trapnull = 0x2122122F;
_memmap_cacheattr_bp_trapnull = 0x2222222F;
_memmap_cacheattr_wb_strict = 0x24F24FFF;
_memmap_cacheattr_wt_strict = 0x21F21FFF;
_memmap_cacheattr_bp_strict = 0x22F22FFF;
_memmap_cacheattr_wb_allvalid = 0x24224222;
_memmap_cacheattr_wt_allvalid = 0x21221222;
_memmap_cacheattr_bp_allvalid = 0x22222222;
PROVIDE(_memmap_cacheattr_reset = _memmap_cacheattr_wb_trapnull);
/*
 *  Other commands and functions of interest:
 *	PROVIDE(var = value);
 *	ABSOLUTE(e)		non-section-relative expr
 *	ADDR(e)			vaddr
 *	LOADADDR(e)		paddr (=vaddr if not AT())
 *	ALIGN(e)		(. + e - 1) & ~(e - 1)
 *	NEXT(e)			like ALIGN(), but if MEMORY is used, may skip to next available region
 *	DEFINED(sym)		1 if sym defined, else 0
 *	SIZEOF(section)		size of section if allocated
 *	SIZEOF_HEADERS		size in byte of output file's headers
 *	MAX(e1,e2)
 *	MIN(e1,e2)
 */
/*
 *  Mapping of input sections to output sections when linking.
 *
 *  Entries are of the form:
 *	SECNAME START BLOCK(ALIGN) (NOLOAD) : AT ( LDADR )
 *		{ CONTENTS } >REGION :PHDR [... or :NONE] =FILL
 *  or
 *	/DISCARD/ : { IGNORED_SECTIONS... }
 *
 *  Also in sections:
 *	BYTE(e) SHORT(e) LONG(e) QUAD(e) SQUAD(e)
 */

SECTIONS
{

  /*  -Ttext moves vaddr of what follows:  */
  .text 0xC0000000 : ALIGN(4)
  {
    _stext = .;
    _text_start = ABSOLUTE(.);
    *(.entry.text)
    *(.init.literal)
    KEEP(*(.init))
    *(.literal .text .literal.* .text.* .stub .gnu.warning .gnu.linkonce.literal.* .gnu.linkonce.t.*.literal .gnu.linkonce.t.*)
    *(.fini.literal)
    KEEP(*(.fini))
    *(.gnu.version)
    *(.sram.rodata)
    *(.rodata)
    *(.rodata.*)
    *(.gnu.linkonce.r.*)
    *(.rodata1)
    __XT_EXCEPTION_TABLE__ = ABSOLUTE(.);
    KEEP (*(.xt_except_table))
    KEEP (*(.gcc_except_table))
    *(.gnu.linkonce.e.*)
    *(.gnu.version_r)
    KEEP (*(.eh_frame))
    /*  C++ constructor and destructor tables, properly ordered:  */
    KEEP (*crtbegin.o(.ctors))
    KEEP (*(EXCLUDE_FILE (*crtend.o) .ctors))
    KEEP (*(SORT(.ctors.*)))
    KEEP (*(.ctors))
    KEEP (*crtbegin.o(.dtors))
    KEEP (*(EXCLUDE_FILE (*crtend.o) .dtors))
    KEEP (*(SORT(.dtors.*)))
    KEEP (*(.dtors))
    /*  C++ exception handlers table:  */
    __XT_EXCEPTION_DESCS__ = ABSOLUTE(.);
    *(.xt_except_desc)
    *(.gnu.linkonce.h.*)
    __XT_EXCEPTION_DESCS_END__ = ABSOLUTE(.);
    *(.xt_except_desc_end)
    *(.dynamic)
    *(.gnu.version_d)
    . = ALIGN(4);		/* this table MUST be 4-byte aligned */
    _bss_table_start = ABSOLUTE(.);
    LONG(_dram0_bss_start)
    LONG(_dram0_bss_end)
    LONG(_dram1_bss_start)
    LONG(_dram1_bss_end)
    LONG(_bss_start)
    LONG(_bss_end)
    _bss_table_end = ABSOLUTE(.);
    *(.sram.literal .sram.text)
    . = ALIGN (4);
    _text_end = ABSOLUTE(.);
    _etext = .;
  } >ALLMEMORY :sram0_phdr

  /*  -Tdata moves vaddr of what follows:  */
  .data : ALIGN(4)
  {
    _data_start = ABSOLUTE(.);
    *(.data)
    *(.data.*)
    *(.gnu.linkonce.d.*)
    KEEP(*(.gnu.linkonce.d.*personality*))
    *(.data1)
    *(.sdata)
    *(.sdata.*)
    *(.gnu.linkonce.s.*)
    *(.sdata2)
    *(.sdata2.*)
    *(.gnu.linkonce.s2.*)
    KEEP(*(.jcr))
    *(.sram.data)
    . = ALIGN(4);
    _rom_store_table = .;
    LONG(_dram0_rodata_start);
    LONG(_dram0_rodata_end);
    LONG(LOADADDR(.dram0.rodata));
    LONG(_dram0_literal_start);
    LONG(_dram0_literal_end);
    LONG(LOADADDR(.dram0.literal));
    LONG(_dram0_data_start);
    LONG(_dram0_data_end);
    LONG(LOADADDR(.dram0.data));
    LONG(_dram1_rodata_start);
    LONG(_dram1_rodata_end);
    LONG(LOADADDR(.dram1.rodata));
    LONG(_Level2InterruptVector_literal_start);
    LONG(_Level2InterruptVector_literal_end);
    LONG(LOADADDR(.Level2InterruptVector.literal));
    LONG(_Level3InterruptVector_literal_start);
    LONG(_Level3InterruptVector_literal_end);
    LONG(LOADADDR(.Level3InterruptVector.literal));
    LONG(_Level4InterruptVector_literal_start);
    LONG(_Level4InterruptVector_literal_end);
    LONG(LOADADDR(.Level4InterruptVector.literal));
    LONG(_DebugExceptionVector_literal_start);
    LONG(_DebugExceptionVector_literal_end);
    LONG(LOADADDR(.DebugExceptionVector.literal));
    LONG(_NMIExceptionVector_literal_start);
    LONG(_NMIExceptionVector_literal_end);
    LONG(LOADADDR(.NMIExceptionVector.literal));
    LONG(_KernelExceptionVector_literal_start);
    LONG(_KernelExceptionVector_literal_end);
    LONG(LOADADDR(.KernelExceptionVector.literal));
    LONG(_UserExceptionVector_literal_start);
    LONG(_UserExceptionVector_literal_end);
    LONG(LOADADDR(.UserExceptionVector.literal));
    LONG(_DoubleExceptionVector_literal_start);
    LONG(_DoubleExceptionVector_literal_end);
    LONG(LOADADDR(.DoubleExceptionVector.literal));
    LONG(_iram0_literal_start);
    LONG(_iram0_literal_end);
    LONG(LOADADDR(.iram0.literal));
    LONG(_iram1_literal_start);
    LONG(_iram1_literal_end);
    LONG(LOADADDR(.iram1.literal));
    LONG(_ResetVector_literal_start);
    LONG(_ResetVector_literal_end);
    LONG(LOADADDR(.ResetVector.literal));
    LONG(_dram1_literal_start);
    LONG(_dram1_literal_end);
    LONG(LOADADDR(.dram1.literal));
    LONG(_dram1_data_start);
    LONG(_dram1_data_end);
    LONG(LOADADDR(.dram1.data));
    LONG(_WindowVectors_text_start);
    LONG(_WindowVectors_text_end);
    LONG(LOADADDR(.WindowVectors.text));
    LONG(_Level2InterruptVector_text_start);
    LONG(_Level2InterruptVector_text_end);
    LONG(LOADADDR(.Level2InterruptVector.text));
    LONG(_Level3InterruptVector_text_start);
    LONG(_Level3InterruptVector_text_end);
    LONG(LOADADDR(.Level3InterruptVector.text));
    LONG(_Level4InterruptVector_text_start);
    LONG(_Level4InterruptVector_text_end);
    LONG(LOADADDR(.Level4InterruptVector.text));
    LONG(_DebugExceptionVector_text_start);
    LONG(_DebugExceptionVector_text_end);
    LONG(LOADADDR(.DebugExceptionVector.text));
    LONG(_NMIExceptionVector_text_start);
    LONG(_NMIExceptionVector_text_end);
    LONG(LOADADDR(.NMIExceptionVector.text));
    LONG(_KernelExceptionVector_text_start);
    LONG(_KernelExceptionVector_text_end);
    LONG(LOADADDR(.KernelExceptionVector.text));
    LONG(_UserExceptionVector_text_start);
    LONG(_UserExceptionVector_text_end);
    LONG(LOADADDR(.UserExceptionVector.text));
    LONG(_DoubleExceptionVector_text_start);
    LONG(_DoubleExceptionVector_text_end);
    LONG(LOADADDR(.DoubleExceptionVector.text));
    LONG(_iram0_text_start);
    LONG(_iram0_text_end);
    LONG(LOADADDR(.iram0.text));
    LONG(_iram1_text_start);
    LONG(_iram1_text_end);
    LONG(LOADADDR(.iram1.text));
    LONG(0);
    LONG(0);
    LONG(0);
    _rom_store = .;
    . = ALIGN (4);
    _data_end = ABSOLUTE(.);
  } >ALLMEMORY :sram0_phdr
  PROVIDE(__stack = 0xd0000000);
  _heap_sentry = 0xd0000000;

  .dram0.rodata : AT(LOADADDR(.data) + ((SIZEOF(.data) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _dram0_rodata_start = ABSOLUTE(.);
    *(.dram0.rodata)
    . = ALIGN (4);
    _dram0_rodata_end = ABSOLUTE(.);
  } >dram0_0_seg :packed_phdr

  .dram0.literal : AT(LOADADDR(.dram0.rodata) + (ADDR(.dram0.literal) - ADDR(.dram0.rodata))) ALIGN(4)
  {
    _dram0_literal_start = ABSOLUTE(.);
    *(.dram0.literal)
    . = ALIGN (4);
    _dram0_literal_end = ABSOLUTE(.);
  } >dram0_0_seg :packed_phdr

  .dram0.data : AT(LOADADDR(.dram0.literal) + (ADDR(.dram0.data) - ADDR(.dram0.literal))) ALIGN(4)
  {
    _dram0_data_start = ABSOLUTE(.);
    *(.dram0.data)
    . = ALIGN (4);
    _dram0_data_end = ABSOLUTE(.);
  } >dram0_0_seg :packed_phdr

  .dram0.bss (NOLOAD) : ALIGN(8)
  {
    . = ALIGN (8);
    _dram0_bss_start = ABSOLUTE(.);
    *(.dram0.bss)
    . = ALIGN (8);
    _dram0_bss_end = ABSOLUTE(.);
    _memmap_seg_dram0_0_end = ALIGN(0x8);
  } >dram0_0_seg :NONE

  .dram1.rodata : AT(LOADADDR(.dram0.data) + ((SIZEOF(.dram0.data) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _dram1_rodata_start = ABSOLUTE(.);
    *(.dram1.rodata)
    . = ALIGN (4);
    _dram1_rodata_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .Level2InterruptVector.literal : AT(LOADADDR(.dram1.rodata) + (ADDR(.Level2InterruptVector.literal) - ADDR(.dram1.rodata))) ALIGN(4)
  {
    _Level2InterruptVector_literal_start = ABSOLUTE(.);
    *(.Level2InterruptVector.literal)
    . = ALIGN (4);
    _Level2InterruptVector_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .Level3InterruptVector.literal : AT(LOADADDR(.Level2InterruptVector.literal) + (ADDR(.Level3InterruptVector.literal) - ADDR(.Level2InterruptVector.literal))) ALIGN(4)
  {
    _Level3InterruptVector_literal_start = ABSOLUTE(.);
    *(.Level3InterruptVector.literal)
    . = ALIGN (4);
    _Level3InterruptVector_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .Level4InterruptVector.literal : AT(LOADADDR(.Level3InterruptVector.literal) + (ADDR(.Level4InterruptVector.literal) - ADDR(.Level3InterruptVector.literal))) ALIGN(4)
  {
    _Level4InterruptVector_literal_start = ABSOLUTE(.);
    *(.Level4InterruptVector.literal)
    . = ALIGN (4);
    _Level4InterruptVector_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .DebugExceptionVector.literal : AT(LOADADDR(.Level4InterruptVector.literal) + (ADDR(.DebugExceptionVector.literal) - ADDR(.Level4InterruptVector.literal))) ALIGN(4)
  {
    _DebugExceptionVector_literal_start = ABSOLUTE(.);
    *(.DebugExceptionVector.literal)
    . = ALIGN (4);
    _DebugExceptionVector_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .NMIExceptionVector.literal : AT(LOADADDR(.DebugExceptionVector.literal) + (ADDR(.NMIExceptionVector.literal) - ADDR(.DebugExceptionVector.literal))) ALIGN(4)
  {
    _NMIExceptionVector_literal_start = ABSOLUTE(.);
    *(.NMIExceptionVector.literal)
    . = ALIGN (4);
    _NMIExceptionVector_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .KernelExceptionVector.literal : AT(LOADADDR(.NMIExceptionVector.literal) + (ADDR(.KernelExceptionVector.literal) - ADDR(.NMIExceptionVector.literal))) ALIGN(4)
  {
    _KernelExceptionVector_literal_start = ABSOLUTE(.);
    *(.KernelExceptionVector.literal)
    . = ALIGN (4);
    _KernelExceptionVector_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .UserExceptionVector.literal : AT(LOADADDR(.KernelExceptionVector.literal) + (ADDR(.UserExceptionVector.literal) - ADDR(.KernelExceptionVector.literal))) ALIGN(4)
  {
    _UserExceptionVector_literal_start = ABSOLUTE(.);
    *(.UserExceptionVector.literal)
    . = ALIGN (4);
    _UserExceptionVector_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .DoubleExceptionVector.literal : AT(LOADADDR(.UserExceptionVector.literal) + (ADDR(.DoubleExceptionVector.literal) - ADDR(.UserExceptionVector.literal))) ALIGN(4)
  {
    _DoubleExceptionVector_literal_start = ABSOLUTE(.);
    *(.DoubleExceptionVector.literal)
    . = ALIGN (4);
    _DoubleExceptionVector_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .iram0.literal : AT(LOADADDR(.DoubleExceptionVector.literal) + (ADDR(.iram0.literal) - ADDR(.DoubleExceptionVector.literal))) ALIGN(4)
  {
    _iram0_literal_start = ABSOLUTE(.);
    *(.iram0.literal)
    . = ALIGN (4);
    _iram0_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .iram1.literal : AT(LOADADDR(.iram0.literal) + (ADDR(.iram1.literal) - ADDR(.iram0.literal))) ALIGN(4)
  {
    _iram1_literal_start = ABSOLUTE(.);
    *(.iram1.literal)
    . = ALIGN (4);
    _iram1_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .ResetVector.literal : AT(LOADADDR(.iram1.literal) + (ADDR(.ResetVector.literal) - ADDR(.iram1.literal))) ALIGN(4)
  {
    _ResetVector_literal_start = ABSOLUTE(.);
    *(.ResetVector.literal)
    . = ALIGN (4);
    _ResetVector_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .dram1.literal : AT(LOADADDR(.ResetVector.literal) + (ADDR(.dram1.literal) - ADDR(.ResetVector.literal))) ALIGN(4)
  {
    _dram1_literal_start = ABSOLUTE(.);
    *(.dram1.literal)
    . = ALIGN (4);
    _dram1_literal_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .dram1.data : AT(LOADADDR(.dram1.literal) + (ADDR(.dram1.data) - ADDR(.dram1.literal))) ALIGN(4)
  {
    _dram1_data_start = ABSOLUTE(.);
    *(.dram1.data)
    . = ALIGN (4);
    _dram1_data_end = ABSOLUTE(.);
  } >dram1_0_seg :packed_phdr

  .dram1.bss (NOLOAD) : ALIGN(8)
  {
    . = ALIGN (8);
    _dram1_bss_start = ABSOLUTE(.);
    *(.dram1.bss)
    . = ALIGN (8);
    _dram1_bss_end = ABSOLUTE(.);
    _memmap_seg_dram1_0_end = ALIGN(0x8);
  } >dram1_0_seg :NONE

  .ResetVector.text : ALIGN(4)
  {
    _ResetVector_text_start = ABSOLUTE(.);
    KEEP (*(.ResetVector.text))
    . = ALIGN (4);
    _ResetVector_text_end = ABSOLUTE(.);
  } >iram0_0_seg :iram0_0_phdr

  .ResetHandler.text : ALIGN(4)
  {
    _ResetHandler_text_start = ABSOLUTE(.);
    *(.ResetHandler.literal .ResetHandler.text)
    . = ALIGN (4);
    _ResetHandler_text_end = ABSOLUTE(.);
    _memmap_seg_iram0_0_end = ALIGN(0x8);
  } >iram0_0_seg :iram0_0_phdr

  .WindowVectors.text : AT(LOADADDR(.dram1.data) + ((SIZEOF(.dram1.data) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _WindowVectors_text_start = ABSOLUTE(.);
    KEEP (*(.WindowVectors.text))
    . = ALIGN (4);
    _WindowVectors_text_end = ABSOLUTE(.);
    _memmap_seg_iram0_1_end = ALIGN(0x8);
  } >iram0_1_seg :packed_phdr

  .Level2InterruptVector.text : AT(LOADADDR(.WindowVectors.text) + ((SIZEOF(.WindowVectors.text) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _Level2InterruptVector_text_start = ABSOLUTE(.);
    KEEP (*(.Level2InterruptVector.text))
    . = ALIGN (4);
    _Level2InterruptVector_text_end = ABSOLUTE(.);
    _memmap_seg_iram0_2_end = ALIGN(0x8);
  } >iram0_2_seg :packed_phdr

  .Level3InterruptVector.text : AT(LOADADDR(.Level2InterruptVector.text) + ((SIZEOF(.Level2InterruptVector.text) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _Level3InterruptVector_text_start = ABSOLUTE(.);
    KEEP (*(.Level3InterruptVector.text))
    . = ALIGN (4);
    _Level3InterruptVector_text_end = ABSOLUTE(.);
    _memmap_seg_iram0_3_end = ALIGN(0x8);
  } >iram0_3_seg :packed_phdr

  .Level4InterruptVector.text : AT(LOADADDR(.Level3InterruptVector.text) + ((SIZEOF(.Level3InterruptVector.text) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _Level4InterruptVector_text_start = ABSOLUTE(.);
    KEEP (*(.Level4InterruptVector.text))
    . = ALIGN (4);
    _Level4InterruptVector_text_end = ABSOLUTE(.);
    _memmap_seg_iram0_4_end = ALIGN(0x8);
  } >iram0_4_seg :packed_phdr

  .DebugExceptionVector.text : AT(LOADADDR(.Level4InterruptVector.text) + ((SIZEOF(.Level4InterruptVector.text) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _DebugExceptionVector_text_start = ABSOLUTE(.);
    KEEP (*(.DebugExceptionVector.text))
    . = ALIGN (4);
    _DebugExceptionVector_text_end = ABSOLUTE(.);
    _memmap_seg_iram0_5_end = ALIGN(0x8);
  } >iram0_5_seg :packed_phdr

  .NMIExceptionVector.text : AT(LOADADDR(.DebugExceptionVector.text) + ((SIZEOF(.DebugExceptionVector.text) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _NMIExceptionVector_text_start = ABSOLUTE(.);
    KEEP (*(.NMIExceptionVector.text))
    . = ALIGN (4);
    _NMIExceptionVector_text_end = ABSOLUTE(.);
    _memmap_seg_iram0_6_end = ALIGN(0x8);
  } >iram0_6_seg :packed_phdr

  .KernelExceptionVector.text : AT(LOADADDR(.NMIExceptionVector.text) + ((SIZEOF(.NMIExceptionVector.text) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _KernelExceptionVector_text_start = ABSOLUTE(.);
    KEEP (*(.KernelExceptionVector.text))
    . = ALIGN (4);
    _KernelExceptionVector_text_end = ABSOLUTE(.);
    _memmap_seg_iram0_7_end = ALIGN(0x8);
  } >iram0_7_seg :packed_phdr

  .UserExceptionVector.text : AT(LOADADDR(.KernelExceptionVector.text) + ((SIZEOF(.KernelExceptionVector.text) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _UserExceptionVector_text_start = ABSOLUTE(.);
    KEEP (*(.UserExceptionVector.text))
    . = ALIGN (4);
    _UserExceptionVector_text_end = ABSOLUTE(.);
    _memmap_seg_iram0_8_end = ALIGN(0x8);
  } >iram0_8_seg :packed_phdr

  .DoubleExceptionVector.text : AT(LOADADDR(.UserExceptionVector.text) + ((SIZEOF(.UserExceptionVector.text) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _DoubleExceptionVector_text_start = ABSOLUTE(.);
    KEEP (*(.DoubleExceptionVector.text))
    . = ALIGN (4);
    _DoubleExceptionVector_text_end = ABSOLUTE(.);
  } >iram0_9_seg :packed_phdr

  .iram0.text : AT(LOADADDR(.DoubleExceptionVector.text) + (ADDR(.iram0.text) - ADDR(.DoubleExceptionVector.text))) ALIGN(4)
  {
    _iram0_text_start = ABSOLUTE(.);
    *(.iram0.text)
    . = ALIGN (4);
    _iram0_text_end = ABSOLUTE(.);
    _memmap_seg_iram0_9_end = ALIGN(0x8);
  } >iram0_9_seg :packed_phdr

  .iram1.text : AT(LOADADDR(.iram0.text) + ((SIZEOF(.iram0.text) + 3) & 0xFFFFFFFC)) ALIGN(4)
  {
    _iram1_text_start = ABSOLUTE(.);
    *(.iram1.text)
    . = ALIGN (4);
    _iram1_text_end = ABSOLUTE(.);
    _memmap_seg_iram1_0_end = ALIGN(0x8);
  } >iram1_0_seg :packed_phdr

  /*  -Tbss moves vaddr of what follows:  */
  .bss (NOLOAD) : ALIGN(8)
  {
    . = ALIGN (8);
    _bss_start = ABSOLUTE(.);
    *(.dynsbss)
    *(.sbss)
    *(.sbss.*)
    *(.gnu.linkonce.sb.*)
    *(.scommon)
    *(.sbss2)
    *(.sbss2.*)
    *(.gnu.linkonce.sb2.*)
    *(.dynbss)
    *(.bss)
    *(.bss.*)
    *(.gnu.linkonce.b.*)
    *(COMMON)
    *(.sram.bss)
    . = ALIGN (8);
    _bss_end = ABSOLUTE(.);
    _end = ALIGN(0x8);
    PROVIDE(end = ALIGN(0x8));
    _stack_sentry = ALIGN(0x8);
    _memmap_seg_sram0_end = ALIGN(0x8);
  } >ALLMEMORY :NONE
  PROVIDE(__stack = 0xd0000000);
  _heap_sentry = 0xd0000000;
  .rom_store_end LOADADDR(.iram1.text) + SIZEOF(.iram1.text) : 
  { 
    _rom_store_end = .;
  } >sram0_seg
  .debug  0 :  { *(.debug) }
  .line  0 :  { *(.line) }
  .debug_srcinfo  0 :  { *(.debug_srcinfo) }
  .debug_sfnames  0 :  { *(.debug_sfnames) }
  .debug_aranges  0 :  { *(.debug_aranges) }
  .debug_pubnames  0 :  { *(.debug_pubnames) }
  .debug_info  0 :  { *(.debug_info) }
  .debug_abbrev  0 :  { *(.debug_abbrev) }
  .debug_line  0 :  { *(.debug_line) }
  .debug_frame  0 :  { *(.debug_frame) }
  .debug_str  0 :  { *(.debug_str) }
  .debug_loc  0 :  { *(.debug_loc) }
  .debug_macinfo  0 :  { *(.debug_macinfo) }
  .debug_weaknames  0 :  { *(.debug_weaknames) }
  .debug_funcnames  0 :  { *(.debug_funcnames) }
  .debug_typenames  0 :  { *(.debug_typenames) }
  .debug_varnames  0 :  { *(.debug_varnames) }
  .xt.insn 0 :
  {
    KEEP (*(.xt.insn))
    KEEP (*(.gnu.linkonce.x.*))
  }
  .xt.prop 0 :
  {
    KEEP (*(.xt.prop))
    KEEP (*(.xt.prop.*))
    KEEP (*(.gnu.linkonce.prop.*))
  }
  .xt.lit 0 :
  {
    KEEP (*(.xt.lit))
    KEEP (*(.xt.lit.*))
    KEEP (*(.gnu.linkonce.p.*))
  }
  .debug.xt.callgraph 0 :
  {
    KEEP (*(.debug.xt.callgraph .debug.xt.callgraph.* .gnu.linkonce.xt.callgraph.*))
  }
}

